import { addCss} from "../../utility/document/link.js";

class BaseElement extends HTMLElement {
    
    static get observedAttributes() {
        return ['css'];
    }

    get css() { return this.getAttribute('css'); }
    set css(value) { this.setAttribute('css', value); }

    loaded;
    get isLoaded() { return this.loaded; }
    set isLoaded(value) { this.loaded = value; }

    root;
    get shadowRoot() { return this.root; }
    set shadowRoot(value) { this.root = value; }

    constructor(){ 
        super();
        this.isLoaded = false;
    }

    loadCss(){
        this.css.split(' ').forEach(link => { addCss(this.shadowRoot, link) }); 
    }
}

export { BaseElement }