class Minimap extends HTMLElement {  

    static get observedAttributes() {
        return ['map-view', 'template-id', 'auto-load'];
    }

    root;
    get shadowRoot() { return this.root; }
    set shadowRoot(value) { this.root = value; }

    loaded;

    constructor(){ 
        super();
    }

    connectedCallback() {
        this.root = this.attachShadow({ mode: "open" });
        if(this.getAttribute('auto-load')){
            this.loadTemplate();
        }
    }

    loadTemplate(){
        if(!this.loaded){
            let templateId = this.getAttribute('template-id');
            if(templateId)
            {
                let templateContent = document.getElementById(templateId).content;
                this.root.appendChild(templateContent.cloneNode(true));
                this.loaded = true;
            }
        }
    }

    show() { this.setAttribute('map-view', ''); }
    hide() { this.removeAttribute('map-view'); }
}

customElements.define('ohl-minimap', Minimap);